#include <avr/io.h>
#include <string.h>
#include "bam_conf.h"

extern uint8_t bam_values[];

#define BamStep(a) if(value & (1<<(a))) buffer[a] |= i;
#define BamStep2(a) BamStep(a); BamStep(a+1)
#define BamStep4(a) BamStep2(a); BamStep2(a+2)
#define BamStep8(a) BamStep4(a); BamStep4(a+4)
#define BamStep16(a) BamStep8(a); BamStep8(a+8)

void BamSetValues8(uint16_t* values)
{
	uint8_t buffer[BAM_RESOLUTION];
	memset(buffer, 0, sizeof(buffer));
	
	for(uint_fast8_t i = 1; i != 0; i <<= 1)
	{
		uint_fast16_t value = *values++;
		BamStep16(0);
	}
	memcpy(bam_values+2, buffer, sizeof(buffer));
}

void BamInit(void)
{
	BAM_DDR |= 0xff;
	TCCR0B = 1<<CS00;
	TIMSK0 = 1<<TOIE0;
}